/* code gegenereerd door Maphoon 3.2 */
/* C. Hans de Nivelle, sept 1989     */


#define ERRORIS(X) ma_errortel = X
#define ERROK      ma_errortel = 0
#define ACCEPTEER  longjmp ( ma_accepteer, 1)
#define ERROR      longjmp ( ma_errret, 1);

#define MA_ACCACT       - 16384
#define MA_ERRACT       - 16385
#define MA_DEFACT       - 16386

#define CODERROR     -1
#define CODEIND      -2
#define CODDEF       -3
#define CODNIL       -20000

%$%
/* de defines vooral */

#ifndef MA_STACK
#define MA_STACK 100
#endif

#ifndef MA_MAXERROR
#define MA_MAXERROR 20
#endif


extern int ma_regelnum [];
extern int ma_linkerk [];
extern int ma_rklengtes [];
extern int ma_acties [];
extern int ma_toestind [];
extern int ma_link [];
extern int ma_def [];
extern int ma_tekencodes [];
extern int ma_bepactie ();
extern void ma_code ();

int ma_lookahead;
MA_STYPE ma_attr [ MA_STACK ], MA_ATTR;
int ma_toest [ MA_STACK ];
int ma_toestsp;

jmp_buf ma_errret;
jmp_buf ma_accepteer;

int MA_PARSE ()
{
   int ma_actie, ma_regel;
   int ma_errortel;
   int ma_rkantlen;
   MA_STYPE ma_nieuw, * ma_tos;

%$%
   ma_errortel = 0;
   ma_toest [0] = 0;
   ma_toestsp = 1;

   if ( setjmp ( ma_errret )) goto ma_eeee;
   if ( setjmp ( ma_accepteer )) return (0);

   ma_lookahead = CODNIL;

   while (1)
   {
      ma_actie = ma_bepactie ( ma_toest [ma_toestsp - 1],
                               & ma_lookahead );
      if ( ma_actie == MA_ACCACT ) ACCEPTEER;
      if ( ma_actie > 0 && ma_actie != MA_ERRACT )
      {
         /* shift */
         ma_toest [ ma_toestsp ] = ma_actie;
         ma_attr [ ma_toestsp ++ ] = MA_ATTR;
#ifdef MA_DEBUG
         printf ("shift %d, ", ma_actie );
#endif
         if ( ma_toestsp >= MA_STACK - 1)
            goto ma_stackoverfl;
         ma_lookahead = CODNIL;
         if ( ma_errortel > 0 ) ma_errortel --;
      }
      else
      {
         if ( ma_actie != MA_ERRACT )
         {
            /* reductie */
            ma_regel = - ma_actie;
            ma_rkantlen = ma_rklengtes [ ma_regel ];
            ma_toestsp -= ma_rkantlen;
            ma_tos = ma_attr + ma_toestsp;
            ma_nieuw = ma_tos [0];   /* default-actie */
#ifdef MA_DEBUG
            printf ("red %d, tot S%d, ",
               ma_regelnum [ ma_regel], ma_toest [ ma_toestsp - 1 ] );
#endif
            switch ( ma_regelnum [ ma_regel ] )
            {
%$%
default:
	 ;
            }

            ma_actie = ma_bepactie ( ma_toest [ ma_toestsp - 1],
                                     ma_linkerk + ma_regel );
#ifdef MA_DEBUG
            printf ("goto %d\n", ma_actie );
#endif
            ma_attr [ ma_toestsp ] = ma_nieuw;
            ma_toest [ ma_toestsp ++ ] = ma_actie;
         }
         else
         {
              /* error  */
            int ma_index [ MA_MAXERROR ], ma_nieuwtoest [MA_MAXERROR ];
            int ma_tel;
            int ma_coderror = CODERROR;

#ifdef MA_DEBUG
            printf ("error ");
#endif
         ma_eeee:
            if ( ma_errortel == 0 )
               if ( MA_ERR () ) return 1;
            ma_tel = 0;
            for ( ma_errortel = ma_toestsp-1;ma_errortel >=0;ma_errortel --)
            {
               if ( ( ma_actie = ma_bepactie ( ma_toest[ma_errortel ],
                    & ma_coderror ) ) >= 0 && ma_actie != MA_ERRACT )
               {
                  ma_index [ma_tel]  = ma_errortel;
                  ma_nieuwtoest [ ma_tel ++ ] = ma_actie;
                  if ( ma_tel >= MA_MAXERROR - 1)
                     goto ma_stackoverfl;
               }
            }
            if ( ma_tel == 0 )
               return 1;
            ma_actie = -1;
            do
            {
               ma_errortel = 0;
               while ( ma_errortel < ma_tel &&
                       ( ma_actie < 0 || ma_actie == MA_ERRACT )  )
               {
                  ma_actie =
                     ma_bepactie ( ma_nieuwtoest [ ma_errortel],
                                    & ma_lookahead );
                  if ( ma_actie < 0 || ma_actie == MA_ERRACT )
                     ma_errortel ++;
               }
               if ( ma_errortel == ma_tel )
               {
                  if ( ma_lookahead != CODEIND )
                  {
                     ma_lookahead = CODNIL;
                  }
               }
            }
            while ( ma_errortel == ma_tel && ma_lookahead != CODEIND );
            if ( ma_errortel == ma_tel && ma_lookahead == CODEIND )
               return 1;

            ma_toestsp = ma_index [ ma_errortel ] + 1;
            ma_toest [ ma_toestsp ++ ] = ma_nieuwtoest [ ma_errortel ];
#ifdef MA_DEBUG
            printf ("herstel in S%d\n", ma_toest [ ma_toestsp - 1] );
#endif
            ma_errortel = 4;
         }
      }
   }
ma_stackoverfl:
   printf ("parse stack is vol\n");
   exit (0);
}


void ma_code ( teken)
int * teken;

{

   register int a = * teken;
#ifdef MA_LAAGSTECODE
   if ( a > MA_LAAGSTECODE + 1 && a < MA_HOOGSTECODE )
      * teken = MA_LAAGSTECODE - a;
   else
   {
      printf ("scanner geeft onbekend teken\n");
      * teken = 0;
   }
#else
   register int *p;

   p = ma_tekencodes;
   while ( * p )
   {
      if ( * p == a )
      {
         * teken = * ( p + 1);
         return;
      }
      p += 2;
   }
   printf ("scanner geeft onbekend teken\n");
   * teken = 0;
#endif
   return;
}



int ma_bepactie ( toest, teken )
int toest;
int * teken;
{
   register int  * p, *q;
   register int a, def;
#if MA_REDVOORUIT
   if ( * teken == CODNIL &&
        ma_toestind [ toest ] == ma_toestind [ toest + 1 ] &&
        ma_link [ toest ] < 0
      )
   {
      return  ma_def [ toest ];
   }
#endif
   if ( * teken == CODNIL )
   {
      * teken = MA_SCAN ();
#ifdef MA_DEBUG
      printf ("tek %d, ", * teken );
#endif
      ma_code ( teken );
   }
   a = * teken;
   def = ma_def [ toest ];
   while (1)
   {
      p = ma_acties + ma_toestind [ toest ];
      q = ma_acties + ma_toestind [ toest + 1 ];
      while ( p < q )
      {
         if ( * p == a )
         {
            a = * ( p + 1 );
            if ( a != MA_DEFACT )
               return a;
            else
               return def;
         }
         p += 2;
      }
      toest = ma_link [ toest ];
      if ( toest < 0 )
         return def;
   }
}

%$%

